# Description:
#   What you are referring to is actually GNU + Linux....
#
# Configuration:
#   None
#
# Author:
#   Enrico Fasoli (fazo96)

image1 = 'https://lut.im/trSfl2cdfX/TDIkX3SjLhKJ2qm5.jpg'
image2 = 'https://lut.im/PLRw8AxYlI/UYH3pv7MWkROQ2BW.jpg'

song = 'https://www.youtube.com/watch?v=9sJUDx7iEJw'

interjection = "
I’d just like to interject for a moment. What you’re referring to as Linux, is
in fact, GNU/Linux, or as I’ve recently taken to calling it, GNU plus Linux.
Linux is not an operating system unto itself, but rather another free component
of a fully functioning GNU system made useful by the GNU corelibs, shell
utilities and vital system components comprising a full OS as defined by POSIX.

Many computer users run a modified version of the GNU system every day, without
realizing it. Through a peculiar turn of events, the version of GNU which is
widely used today is often called “Linux”, and many of its users are not aware
that it is basically the GNU system, developed by the GNU Project.

There really is a Linux, and these people are using it, but it is just a part of
the system they use. Linux is the kernel: the program in the system that
allocates the machine’s resources to the other programs that you run. The kernel
is an essential part of an operating system, but useless by itself; it can only
function in the context of a complete operating system. Linux is normally used
in combination with the GNU operating system: the whole system is basically GNU
with Linux added, or GNU/Linux. All the so-called “Linux” distributions are
really distributions of GNU/Linux.
"

interjection_es = "
Me gustaría interponer por un sólo momento. Lo que usted se refiere como Linux,
es, de hecho, GNU/Linux, o como recientemente yo he empezado a llamar, GNU plus
Linux. Linux no es un sistema operativo en sí mismo, sino más bien otro
componente libre de un sistema GNU enteramente functional, hacho útil por los
GNU corelibs, utilidades de shell y los componentes vitales del sistema que
comprende un sistema operativo completo según lo definido por POSIX.

Muchos usuarios de computadoras ejecutan una versión modificada del sistema GNU
todos los días, sin darse cuenta. A través de un giro peculiar de eventos, la
versión de GNU, que es ampliamente utilizado hoy en día es a menudo llamado
“Linux”, y muchos de sus usuarios no son conscientes de que es básicamente el
sistema GNU, desarrollado por el proyecto GNU.

Realmente hay un Linux, y estas personas lo están utilizando, pero es sólo una
parte del sistema que utilizan. Linux es el núcleo: el programa en el sistema
que asigna los recursos de la máquina a los otros programas que se ejecutan.
El núcleo es una parte esencial de un sistema operativo, pero inútil por sí
mismo; sólo puede funcionar en el contexto de un sistema operativo completo.
Linux se utiliza normalmente en combinación con el sistema operativo GNU:
todo el sistema es básicamente GNU con Linux agregado, o GNU/Linux. Todas las
llamadas distribuciones de “Linux” son realmente distribuciones de GNU/Linux.
"

module.exports = (robot) ->
  robot.hear /linux/i, (res) ->
    s = res.message.text
    if not s.match /(GNU ?[+\/])|(kernel )Linux/i
        if Math.random() < 0.1
          res.send image2, interjection_es, song
        else
          res.send image1, interjection
